import java.util.Vector; 

public class BPostfixExpression extends BExpression
{ private String operator;
  private BExpression argument;

  public BPostfixExpression(String op, BExpression arg)
  { operator = op;
    argument = arg;
  }

  public boolean setValued()
  { if (operator.equals("~"))
    { return true; }
    return false;   //  
  }

  public Vector rd()
  { return argument.rd(); } 

  public BExpression simplify()
  { BExpression b1 = argument.simplify();
    if (b1 instanceof BPostfixExpression)
    { BPostfixExpression pf = (BPostfixExpression) b1; 
      if (pf.operator.equals("~"))
      { return pf.argument; } 
    } 
    return new BPostfixExpression(operator,b1); 
  } 

  public String toString() 
  { return "(" + argument + ")" + operator; }

  public BExpression substituteEq(String oldE, BExpression newE)
  { if (oldE.equals(toString()))
    { return newE; } 
    return new BPostfixExpression(operator,
                                argument.substituteEq(oldE,newE)); 
  }
}

