import java.util.Vector; 

/* Copyright K. Lano 2013
   Package: ATL 
*/ 

public class OutPattern
{ Vector elements; // OutPatternElement

  public OutPattern()
  { elements = new Vector(); } 

  public void setElements(Vector elems)
  { elements = elems; } 

  public void addElement(OutPatternElement ipe) 
  { elements.add(ipe); } 

  public Vector allVariables()
  { Vector res = new Vector(); 
    for (int i = 0; i < elements.size(); i++) 
    { OutPatternElement ope = (OutPatternElement) elements.get(i); 
      res.add(ope.variable); 
    } 
    return res; 
  } 

  public String toString()
  { String res = "to "; 
    for (int i = 0; i < elements.size(); i++) 
    { OutPatternElement pe = (OutPatternElement) elements.get(i); 
      res = res + pe; 
      if (i < elements.size() - 1) 
      { res = res + ",\n    "; } 
    } 
    return res; 
  } 

  public Expression toExpression(Vector types, Vector ents, Vector env, 
                                 java.util.Map interp) 
  { Expression res = new BasicExpression("true"); 
    for (int i = 0; i < elements.size(); i++)
    { OutPatternElement ipe = (OutPatternElement) elements.get(i); 
      Expression exp = ipe.toExpression(types,ents,env,interp);
      if (exp != null) 
      { res = Expression.simplify("&",res,exp,null); } 
    } 
    return res; 
  } 

  public Vector sourceTypesRead()
  { Vector res = new Vector(); 
    for (int i = 0; i < elements.size(); i++) 
    { OutPatternElement ipe = (OutPatternElement) elements.get(i); 
      res.addAll(ipe.sourceTypesRead()); 
    } 
    return res; 
  } 

  public boolean hasType(String typ) 
  { // typ occurs as an output type of the pattern, or superclass of such a type
    for (int i = 0; i < elements.size(); i++)
    { OutPatternElement ipe = (OutPatternElement) elements.get(i); 
      if (typ.equals(ipe.variable.getType() + ""))
      { return true; } 
    } 
    return false; 
  } 

  public OutPattern slice()
  { OutPattern res = new OutPattern(); 
    for (int i = 0; i < elements.size(); i++) 
    { OutPatternElement ep = (OutPatternElement) elements.get(i); 
      Vector bnds = ep.slice(); 
      OutPatternElement newep = new OutPatternElement(ep.variable);
      newep.setBindings(bnds); 
      res.addElement(newep); 
    } // and remove bnds from ep.bindings
    return res; 
  }  
      
    
}