import java.util.Vector; 


public class OutPatternElement
{ Attribute variable; 
  Vector bindings; // Binding

  public OutPatternElement(Attribute att)
  { variable = att; 
    bindings = new Vector(); 
  } 

  public void setBindings(Vector elems)
  { bindings = elems; } 

  public void addBinding(Binding ipe) 
  { bindings.add(ipe); } 

  public String toString()
  { String res = variable.getName() + " : " + variable.getType() + " (\n"; 
    for (int i = 0; i < bindings.size(); i++) 
    { Binding bn = (Binding) bindings.get(i); 
      res = res + "    " + bn; 
      if (i < bindings.size() - 1)
      { res = res + ",\n"; } 
    } 
    return res + ")"; 
  } 

  public String getType()
  { return variable.getType() + ""; } 

  public Entity getEntity()
  { Type t = variable.getType(); 
    if (t.isEntity())
    { return t.getEntity(); }
    return null; 
  }  

  public Expression toExpression(Vector types, Vector ents, Vector env, java.util.Map interp) 
  { // typ->exists( var | var.$id = $id & bind1exp & ... & bindnexp ) 
    Type typ = variable.getType(); // Must be a target entity type. 
    String nme = variable.getName(); // If nme : env.name, need to @pre in binding RHS
    BasicExpression var = new BasicExpression(nme); 
    var.setType(typ); 
    var.setMultiplicity(ModelElement.ONE);  
    BasicExpression id = new BasicExpression("$id"); 
    id.setType(new Type("String",null)); 
    id.setMultiplicity(ModelElement.ONE); 
    BasicExpression varid = new BasicExpression("$id"); 
    varid.setType(new Type("String",null)); 
    varid.setMultiplicity(ModelElement.ONE); 
    varid.setObjectRef(var); 
    Expression res = new BasicExpression("true"); 
    ModelElement met = ModelElement.lookupByName(nme, env);
    if (met == null) 
    { res = new BinaryExpression("=",varid,id); } 
 
    for (int i = 0; i < bindings.size(); i++)
    { Binding ipe = (Binding) bindings.get(i); 
      Expression bexp = ipe.toExpression(nme,typ,types,ents,env,interp); 
      if (bexp != null) 
      { res = Expression.simplify("&",res,bexp,null); } 
    } 
    return res; 
    // return new BinaryExpression("#", new BinaryExpression(":",
    //                                    new BasicExpression(nme), new BasicExpression(typ + "")),
    //                                  res); 
  } 

  public Vector sourceTypesRead()
  { Vector res = new Vector(); 
    for (int i = 0; i < bindings.size(); i++) 
    { Binding bn = (Binding) bindings.get(i); 
      res.addAll(bn.sourceTypesRead()); 
    } 
    return res; 
  }

  public Vector slice()
  { // returns the bindings that update association ends 
    Vector res = new Vector(); 
    for (int i = 0; i < bindings.size(); i++) 
    { Binding bnd = (Binding) bindings.get(i); 
      if (variable.getType().isEntity() && 
          bnd.isAssociationUpdate(variable.getType().getEntity()))
      { res.add(bnd); } 
    } 
    bindings.removeAll(res); 
    return res; 
  } 
}