import java.util.Vector; 

/* Copyright K. Lano 2015
   Package: QVT
*/ 

public class Pattern
{ Vector bindsTo = new Vector(); // of Attribute
  Vector predicate = new Vector(); // of Expression

  public Object clone()
  { Pattern res = new Pattern(); 
    res.bindsTo = bindsTo; 
    for (int i = 0; i < predicate.size(); i++) 
    { Expression e = (Expression) predicate.get(i); 
      Expression e1 = (Expression) e.clone(); 
      res.addPredicate(e1); 
    } 
    return res; 
  } 

  public void addBindsTo(Attribute b)
  { bindsTo.add(b); }

  public void addPredicate(Expression p)
  { predicate.add(p); }

  public String toString()
  { String res = ""; 
    for (int i = 0; i < predicate.size(); i++) 
    { res = res + predicate.get(i); 
      if (i < predicate.size() - 1)
      { res = res + " & "; } 
    } 
    return res; 
  }  

  public Expression toSourceExpression(Vector bound, Expression contextObj)
  { return null; }

  public Expression toTargetExpression(Vector bound, Expression contextObj)
  { return null; }

  public Expression toSourceExpressionOp(Vector bound, Expression contextObj)
  { return null; }

  public Expression toTargetExpressionOp(Vector bound, Expression contextObj)
  { return null; }


  public Expression whenToExp(Vector bound, Vector rules, Vector entities)
  { // R(s,t) 
    Expression res = new BasicExpression("true");
    for (int i = 0; i < predicate.size(); i++)
    { Expression conj = (Expression) predicate.get(i);
      Expression e = conj;
      if (conj != null && conj.isRuleCall(rules) && (conj instanceof BasicExpression))
      { e = ((BasicExpression) conj).testTraceRelation(entities); }
      res = Expression.simplify("&", res, e, null);
    }
    return res;
  }  // also add parameters of call to bound variables with predicate p:T if not in bound

  public Expression whereToExp(Vector bound, Vector rules)
  { // invokes ops for non-top relations
    Expression res = new BasicExpression("true");
    for (int i = 0; i < predicate.size(); i++)
    { Expression conj = (Expression) predicate.get(i);
      Expression e = conj;
      if (conj != null && conj.isRuleCall(rules) && 
          (conj instanceof BasicExpression))
      { e = ((BasicExpression) conj).invokeNontopRule(); }
      res = Expression.simplify("&", res, e, null);
    }
    return res;
  }
}
