import java.util.Vector; 

/* Copyright K. Lano 2015
   Package: QVT
*/ 

public class RelationalTransformation extends NamedElement
{ Vector modelParameter = new Vector(); // of TypedModel
  Vector rule = new Vector(); // of QVTRule

  public RelationalTransformation(String n)
  { super(n); }

  public void addParameter(TypedModel tm)
  { modelParameter.add(tm); }

  public void addRule(QVTRule r)
  { rule.add(r); }

  public boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env)
  { for (int i = 0; i < rule.size(); i++)
    { QVTRule r = (QVTRule) rule.get(i);
      r.typeCheck(types,entities,contexts,env); 
    } 
    return true; 
  } 

  public void addTraceEntities(Vector entities)
  { for (int i = 0; i < rule.size(); i++)
    { QVTRule r = (QVTRule) rule.get(i);
      r.addTraceEntity(entities); 
    } 
  } 

  public UseCase toUseCase(Vector entities, Vector types)
  { UseCase res = new UseCase(getName(),null);
    for (int i = 0; i < rule.size(); i++)
    { Relation r = (Relation) rule.get(i);
      r.getNontopOp(res,entities,types); 
    } 

    Vector ruleclones = new Vector(); 

    for (int i = 0; i < rule.size(); i++)
    { Relation r = (Relation) rule.get(i);
      Relation r1 = (Relation) r.clone(); 
      ruleclones.add(r1); 
    } 

    for (int i = 0; i < rule.size(); i++)
    { QVTRule r = (QVTRule) rule.get(i);
      Constraint c = r.toInverseConstraint(entities,types);
      if (c != null)
      { res.addPostcondition(c); }
    }
      
    for (int i = 0; i < ruleclones.size(); i++)
    { QVTRule r1 = (QVTRule) ruleclones.get(i); 
      Constraint c = r1.toConstraint(entities,types);
      if (c != null)
      { res.addPostcondition(c); }
    }
    return res;
  }

  public String toString()
  { String res = "transformation " + getName() + "\n" + 
      "{ "; 
    for (int i = 0; i < rule.size(); i++) 
    { QVTRule r = (QVTRule) rule.get(i);      
      res = res + r + "\n\n"; 
    } 
    return res + "}"; 
  } 

}
