import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class TextDisplay extends JFrame  
{  // the area for text output:
  private JTextArea text = new JTextArea(); 
  
  public TextDisplay() 
  { addWindowListener(     /* Kills display when */
      new WindowAdapter()  /* window is closed.      */ 
      { public void windowClosing(WindowEvent e) 
        { setVisible(false);
          dispose();
        }   
      });  

    Container contentPane = getContentPane();
    
    JScrollPane scroller = 
      new JScrollPane(text,      
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    scroller.setPreferredSize(new Dimension(300,600));
    contentPane.add(scroller, BorderLayout.CENTER);
    setSize(300,400);
    show();
  }

  public TextDisplay(String title, String file)
  { this();
    setTitle(title);
    text.setFont(new Font("Serif",Font.BOLD,18)); 
    displayFile(file);
  }

  private void displayFile(String file)
  { try 
    { FileReader fr = new FileReader(file);
      text.read(fr,null);
      fr.close();
    }
    catch(IOException e)
    { System.err.println("Cannot access " + file); }
  }

  public static void main(String[] args)
  { TextDisplay td = new TextDisplay("Java code",
                            "TextDisplay.java");
  }
}








