#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ocl.h"

#include "app.h"

struct A** a_instances = NULL;
int a_size = 0;

struct B** b_instances = NULL;
int b_size = 0;

struct C** c_instances = NULL;
int c_size = 0;

struct A** newAList(void)
{ return (struct A**) calloc(ALLOCATIONSIZE, sizeof(struct A*)); }

struct B** newBList(void)
{ return (struct B**) calloc(ALLOCATIONSIZE, sizeof(struct B*)); }

struct C** newCList(void)
{ return (struct C**) calloc(ALLOCATIONSIZE, sizeof(struct C*)); }

int getA_x(struct A* self) { return self->x; }

char* getB_id(struct B* self) { return self->id; }

struct C* getB_cr(struct B* self) { return self->cr; }

struct B** getC_br(struct C* self) { return self->br; }

int getB_x(struct B* self) { return getA_x(self->super); }

int getC_x(struct C* self) { return getA_x(self->super); }

void setA_x(struct A* self, int _value) { self->x = _value; }

void setB_id(struct B* self, char* _value) { self->id = _value; }

void setB_cr(struct B* self, struct C* _value) { self->cr = _value; }

void setC_br(struct C* self, struct B** _value) { self->br = _value; }

void setB_x(struct B* self, int _value) { setA_x(self->super, _value); }

void setC_x(struct C* self, int _value) { setA_x(self->super, _value); }

int* getAllA_x(struct A* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getA_x(_col[i]); }
  return result;
}

int* getAllB_x(struct B* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_x(_col[i]); }
  return result;
}

int* getAllC_x(struct C* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_x(_col[i]); }
  return result;
}

char** getAllB_id(struct B* _col[])
{ int n = length((void**) _col);
  char** result = (char**) calloc(n+1, sizeof(char*));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_id(_col[i]); }
  result[n] = NULL;
  return result;
}

struct C** getAllB_cr(struct B* _col[])
{ int n = length((void**) _col);
  struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_cr(_col[i]); }
  result[n] = NULL;
  return result;
}

struct B* getBByPK(char* _ex)
{ int _n = length((void**) b_instances);
  int _i = 0;
  for ( ; _i < _n; _i++)
  { char* _v = getB_id(b_instances[_i]);
    if (_v != NULL && strcmp(_v,_ex) == 0)
    { return b_instances[_i]; }
  }
  return NULL;
}

struct B** getBByPKs(char* _col[])
{ int n = length((void**) _col);
  struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { char* _v = _col[i];
    struct B* _ex = getBByPK(_v);
    if (_ex != NULL)
    { result[j] = _ex; j++; }
  }
  result[j] = NULL;
  return result; }

struct A** appendA(struct A* col[], struct A* ex)
   { struct A** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct A**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct A*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct B** appendB(struct B* col[], struct B* ex)
   { struct B** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct B**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct B*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct C** appendC(struct C* col[], struct C* ex)
   { struct C** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct C**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct C*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

void addA(void* obj)
{ a_instances = appendA(a_instances, (struct A*) obj);
  a_size++;
}

void addB(void* obj)
{ b_instances = appendB(b_instances, (struct B*) obj);
  b_size++;
  addA(obj);
}

void addC(void* obj)
{ c_instances = appendC(c_instances, (struct C*) obj);
  c_size++;
  addA(obj);
}

struct B* createB(char* _value)
{ struct B* result = NULL;
  result = getBByPK(_value);
  if (result != NULL) { return result; }
  result = (struct B*) malloc(sizeof(struct B));
  result->cr = NULL;
  result->super = createA();
  setB_id(result, _value);
  addB(result);
  return result;
}

struct A* createA(void)
{ struct A* result = (struct A*) malloc(sizeof(struct A));
  result->x = 0;
  addA(result);
  return result;
}

struct B* createB(void)
{ struct B* result = (struct B*) malloc(sizeof(struct B));
  result->cr = NULL;
  result->super = createA();
  addB(result);
  return result;
}

struct C* createC(void)
{ struct C* result = (struct C*) malloc(sizeof(struct C));
  result->br = NULL;
  result->super = createA();
  addC(result);
  return result;
}

struct A** insertA(struct A* col[], struct A* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendA(col,self);
  }

struct B** insertB(struct B* col[], struct B* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendB(col,self);
  }

struct C** insertC(struct C* col[], struct C* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendC(col,self);
  }

  struct A** subrangeA(struct A** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct A** result = (struct A**) calloc(j - i + 2, sizeof(struct A*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct B** subrangeB(struct B** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct B** result = (struct B**) calloc(j - i + 2, sizeof(struct B*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct C** subrangeC(struct C** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct C** result = (struct C**) calloc(j - i + 2, sizeof(struct C*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct A** reverseA(struct A** col)
  { int n = length((void**) col);
    struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct B** reverseB(struct B** col)
  { int n = length((void**) col);
    struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct C** reverseC(struct C** col)
  { int n = length((void**) col);
    struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

struct A** removeA(struct A* col[], struct A* ex)
{ int len = length((void**) col);
  struct A** result = (struct A**) calloc(len+1, sizeof(struct A*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct A* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeB(struct B* col[], struct B* ex)
{ int len = length((void**) col);
  struct B** result = (struct B**) calloc(len+1, sizeof(struct B*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct B* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** removeC(struct C* col[], struct C* ex)
{ int len = length((void**) col);
  struct C** result = (struct C**) calloc(len+1, sizeof(struct C*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct C* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** removeAllA(struct A* _col1[], struct A* _col2[])
{ int n = length((void**) _col1);
  struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct A* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeAllB(struct B* _col1[], struct B* _col2[])
{ int n = length((void**) _col1);
  struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct B* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** removeAllC(struct C* _col1[], struct C* _col2[])
{ int n = length((void**) _col1);
  struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct C* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** frontA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 1, n-1); }

struct B** frontB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 1, n-1); }

struct C** frontC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 1, n-1); }

struct A** tailA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 2, n); }

struct B** tailB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 2, n); }

struct C** tailC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 2, n); }

void addC_br(struct C* c_x, struct B* b_x)
{ if (isIn((void*) b_x, (void**) getC_br(c_x)))
  { return;  } 
  if (getB_cr(b_x) != NULL)
  { setC_br(getB_cr(b_x), removeB(getC_br(getB_cr(b_x)), b_x));  } 
  setB_cr(b_x, c_x); 
  setC_br(c_x, insertB(getC_br(c_x), b_x)); 
}

void removeC_br(struct C* c_x, struct B* b_x)
{ setB_cr(b_x, NULL); 
  setC_br(c_x, removeB(getC_br(c_x), b_x)); 
}

void assignB_cr(struct B* b_x, struct C* c_x)
{ if (getB_cr(b_x) != c_x && getB_cr(b_x) != NULL)
  { removeC_br(getB_cr(b_x), b_x); 
  addC_br(c_x, b_x);  } 
}

void killA(struct A* a_x)
{ a_instances = removeA(a_instances, a_x); 
}

void killAbstractA(struct A* a_x)
{ if (isIn((void*) a_x, (void**) c_instances))
  { killC((struct C*) a_x);  }
  else 
  { if (isIn((void*) a_x, (void**) b_instances))
  { killB((struct B*) a_x);  }
  else 
  {  }  } 
}

void killB(struct B* b_x)
{ b_instances = removeB(b_instances, b_x); 
  int ind_boundedloopstatement_146 = 0;
  int size_boundedloopstatement_146 = length((void**) c_instances);
  for ( ; ind_boundedloopstatement_146 < size_boundedloopstatement_146; ind_boundedloopstatement_146++)
  { struct C* c_xx = (c_instances)[ind_boundedloopstatement_146];
    setC_br(c_xx, removeB(getC_br(c_xx), b_x));   } 
  killA(b_x->super); 
  killA((struct A*) b_x); 
  free(b_x); 
}

void killC(struct C* c_x)
{ c_instances = removeC(c_instances, c_x); 
  struct B** b_cr_deleted = NULL; 
  int ind_boundedloopstatement_196 = 0;
  int size_boundedloopstatement_196 = length((void**) b_instances);
  for ( ; ind_boundedloopstatement_196 < size_boundedloopstatement_196; ind_boundedloopstatement_196++)
  { struct B* b_xx = (b_instances)[ind_boundedloopstatement_196];
    if (getB_cr(b_xx) == c_x)
  { setB_cr(b_xx, NULL); 
  b_cr_deleted = insertB(b_cr_deleted, b_xx);  }   } 
  int ind_boundedloopstatement_222 = 0;
  int size_boundedloopstatement_222 = length((void**) b_cr_deleted);
  for ( ; ind_boundedloopstatement_222 < size_boundedloopstatement_222; ind_boundedloopstatement_222++)
  { struct B* b_xx = (b_cr_deleted)[ind_boundedloopstatement_222];
    killB(b_xx);   } 
  free(b_cr_deleted); 
  killA(c_x->super); 
  killA((struct A*) c_x); 
  free(c_x); 
}

int main(int _argc, char* _argv[]) { return 0; }
