import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.util.StringTokenizer;

public class GUI extends JFrame implements ActionListener
{ JPanel panel = new JPanel();
  JPanel tPanel = new JPanel();
  JPanel cPanel = new JPanel();
  Controller cont = Controller.inst();
  JButton loadModelButton = new JButton("loadModel");
  JButton saveModelButton = new JButton("saveModel");
  JButton loadCSVButton = new JButton("loadCSVs");
  JButton saveCSVButton = new JButton("saveCSVs");
  JButton initialisensxButton = new JButton("initialisensx");
  JButton sheetButton = new JButton("sheet");

 public GUI()
  { super("Select use case to execute");
    panel.setLayout(new BorderLayout());
    panel.add(tPanel, BorderLayout.NORTH);
    panel.add(cPanel, BorderLayout.CENTER);
    setContentPane(panel);
    addWindowListener(new WindowAdapter() 
    { public void windowClosing(WindowEvent e)
      { System.exit(0); } });
  tPanel.add(loadModelButton);
  loadModelButton.addActionListener(this);
  tPanel.add(saveModelButton);
  saveModelButton.addActionListener(this);
  tPanel.add(loadCSVButton);
  loadCSVButton.addActionListener(this);
  tPanel.add(saveCSVButton);
  saveCSVButton.addActionListener(this);
  cPanel.add(initialisensxButton);
  initialisensxButton.addActionListener(this);
  cPanel.add(sheetButton);
  sheetButton.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e)
  { if (e == null) { return; }
    String cmd = e.getActionCommand();
    if ("loadModel".equals(cmd))
    { Controller.loadModel("in.txt");
      cont.checkCompleteness();
      System.err.println("Model loaded");
      return; } 
    if ("saveModel".equals(cmd))
    { cont.saveModel("out.txt");  
      cont.saveXSI("xsi.txt"); 
      return; } 
    if ("loadCSVs".equals(cmd))
    { Controller.loadCSVModel();
      System.err.println("Model loaded");
      return; } 
    if ("saveCSVs".equals(cmd))
    { cont.saveCSVModel();  
      return; } 
    if ("initialisensx".equals(cmd))
    { String _vals = JOptionPane.showInputDialog("Enter parameters s1 s2 :");
    Vector _values = new Vector();
    StringTokenizer _st = new StringTokenizer(_vals);
    while (_st.hasMoreTokens())
    { String _se = _st.nextToken().trim();
      _values.add(_se); 
    }

    java.util.List s1 = new Vector();
    File files1 = new File((String) _values.get(0));
    BufferedReader brs1 = null;
    try { brs1 = new BufferedReader(new FileReader(files1)); }
    catch(Exception _e) { System.err.println("no file"); return; }
    while (true)
    { String _s = null; 
      try { _s = brs1.readLine(); }
      catch (Exception _ex) { break; }
      if (_s == null) { break; }
      s1.add(_s); 
    }
    java.util.List s2 = new Vector();
    File files2 = new File((String) _values.get(1));
    BufferedReader brs2 = null;
    try { brs2 = new BufferedReader(new FileReader(files2)); }
    catch(Exception _e) { System.err.println("no file"); return; }
    while (true)
    { String _s = null; 
      try { _s = brs2.readLine(); }
      catch (Exception _ex) { break; }
      if (_s == null) { break; }
      s2.add(_s); 
    }
 cont.initialisensx(s1,s2) ;  return; } 
    if ("sheet".equals(cmd))
    {  cont.sheet() ;  return; } 
  }

  public static void main(String[] args)
  {  GUI gui = new GUI();
    gui.setSize(400,400);
    gui.setVisible(true);
  }
 }
